unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    Label1: TLabel;
    seRange: TSpinEdit;
    RadioGroup1: TRadioGroup;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  public
    procedure SimpleDraw;
    procedure FastDraw;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//==============================================================================
//========== logical function, should be customized by students ================

Function F(x,y: real): boolean;

Var
  inside_small_circle,
  outside_small_romb,
  inside_large_circle,
  outside_large_romb: boolean;

Begin

inside_small_circle := (x*x+y*y) < 5*5;
inside_large_circle := (x*x+y*y) < 10*10;

outside_small_romb  := abs(x)+abs(y) >=5;
outside_large_romb  := abs(x)+abs(y) >=10;

Result:=  (inside_small_circle xor outside_small_romb)
       xor (inside_large_circle xor outside_large_romb);
End;

//==============================================================================
//==============================================================================

procedure TForm1.Button2Click(Sender: TObject);
begin
Close;
end;


procedure TForm1.Button1Click(Sender: TObject);
begin
    if RadioGroup1.ItemIndex=0
        then SimpleDraw
    else
    if RadioGroup1.ItemIndex=1
        then FastDraw;
end;


Procedure TForm.SimpleDraw;
var
  N,                                    // = half-width (=half-height)
  i,j,
  k: integer;                           // = pixels per 1.0 in real coordinates

  x, y,                                 // real coordinates of a current point
   dx, dy: real;                        // = "X's per pixel" = "Y's per pixel"

  b:     boolean;                       // result of boolean function
  R:     byte;                          // range for {X,Y} as {R, R}
  Bmp: TBitmap;

begin
Bmp:=TBitmap.Create;
with Bmp do begin
    PixelFormat:=pf24bit;
    Width := PaintBox1.Width;
    Height:= PaintBox1.Height;
    with Canvas do begin
        Brush.Color:=clBlack;
        FillRect(ClipRect);
    end;
end;

      //== Select area size (in pixels) as N = 0.5 * min(Height, Width)
N:=Bmp.Width  div 2;
i:=Bmp.Height div 2;
if N>i then N:=i;

      //== Select "dx" and "dy" values so as "N pixels" ~ "R units of X"
R:=seRange.Value;
k:=N div R;
if k<1 then k:=1;                       // k = pixels per 1.0 in real coordinates

dx:=1/k;                                // compute "X's per pixel"
dy:=dx;                                 // compute "Y's per pixel" = "X's per pixel"

      //== Paint the areas
for i:=-N to N do
  for j:=-N to N do
    begin                               //  iterate through all pixels
    x:=i*dx;                            // calculate real coordinates from pixel coordinates
    y:=j*dx;

    b:=F(x,y);                          // compute boolean value for the (X,Y) point

      //== colour the pixel
    if b
    then Bmp.Canvas.Pixels[N+i, N-j]:=clWhite
    else Bmp.Canvas.Pixels[N+i, N-j]:=clBlack;
    end;
                  {
                  Sample color names:
                    clBlack   clWhite
                    clRed     clGreen     clBlue
                    clPurple  clYellow    clGray
                    clNavy    clAqua      clSilver
                    clTeal    clLime      clMaroon
                    clOlive   clCream     clFuchsia
                  }

      //== draw 0X and 0Y axes
with Bmp.Canvas do begin
    Pen.Color:=clFuchsia;
    Pen.Style:=psSolid;    // solid lines

    MoveTo( 0 , N);        // draw X axis
    LineTo(2*N, N);

    MoveTo(N,  0);         // draw Y axis
    LineTo(N, 2*N);

      // draw labels on axes
    Pen.Color:=clPurple;
    Pen.Style:=psDot;      // dotted lines
    Pen.Mode:=pmXor;

    for i:=1 to N div k do                  //== draw labels on the X axis
    begin
        MoveTo(N-i*k, N*2);  // for negative values of X
        LineTo(N-i*k,  0 );

        MoveTo(N+i*k, N*2);  // for positive values of X
        LineTo(N+i*k,  0 );
    end;

    for i:=1 to N div k do                  //== draw labels on the Y axis
    begin
        MoveTo(N*2, N-i*k);  // for negative values of y
        LineTo( 0 , N-i*k);

        MoveTo(N*2, N+i*k);  // for positive values of y
        LineTo( 0 , N+i*k);
    end;
end;

PaintBox1.Canvas.CopyRect(PaintBox1.Canvas.ClipRect, Bmp.Canvas, Bmp.Canvas.ClipRect);
Bmp.Free;
end;


Procedure TForm.FastDraw;
var
  N,                                    // = half-width (=half-height)
  i,j,
  k: integer;                           // = pixels per 1.0 in real coordinates

  x, y,                                 // real coordinates of a current point
   dx, dy: real;                        // = "X's per pixel" = "Y's per pixel"

  b:     boolean;                       // result of boolean function
  R:     byte;                          // range for {X,Y} as {R, R}
  Bmp: TBitmap;

  s,e: integer;
  f:   boolean;                         // result of boolean function
begin
Bmp:=TBitmap.Create;
with Bmp do begin
    PixelFormat:=pf24bit;
    Width := PaintBox1.Width;
    Height:= PaintBox1.Height;
    with Canvas do begin
        Brush.Color:=clBlack;
        FillRect(ClipRect);
    end;
end;

      //== Select area size (in pixels) as N = 0.5 * min(Height, Width)
N:=Bmp.Width  div 2;
i:=Bmp.Height div 2;
if N>i then N:=i;

      //== Select "dx" and "dy" values so as "N pixels" ~ "R units of X"
R:=seRange.Value;
k:=N div R;
if k<1 then k:=1;                       // k = pixels per 1.0 in real coordinates

dx:=1/k;                                // compute "X's per pixel"
dy:=dx;                                 // compute "Y's per pixel" = "X's per pixel"

      //== Paint the areas
for i:=-N to N do
begin
    s:=-N-1;
//    e:=-N-1;
    f:=FALSE;
  j:=-N;
  while j<=N do
  begin                               //  iterate through all pixels
    x:=i*dx;                            // calculate real coordinates from pixel coordinates
    y:=j*dx;

    b:=F(x,y);                          // compute boolean value for the (X,Y) point
    if f=b then continue


      //== colour the pixel
    if b
    then Bmp.Canvas.Pixels[N+i, N-j]:=clWhite
    else Bmp.Canvas.Pixels[N+i, N-j]:=clBlack;
    end;
end;
                  {
                  Sample color names:
                    clBlack   clWhite
                    clRed     clGreen     clBlue
                    clPurple  clYellow    clGray
                    clNavy    clAqua      clSilver
                    clTeal    clLime      clMaroon
                    clOlive   clCream     clFuchsia
                  }

      //== draw 0X and 0Y axes
with Bmp.Canvas do begin
    Pen.Color:=clFuchsia;
    Pen.Style:=psSolid;    // solid lines

    MoveTo( 0 , N);        // draw X axis
    LineTo(2*N, N);

    MoveTo(N,  0);         // draw Y axis
    LineTo(N, 2*N);

      // draw labels on axes
    Pen.Color:=clPurple;
    Pen.Style:=psDot;      // dotted lines
    Pen.Mode:=pmXor;

    for i:=1 to N div k do                  //== draw labels on the X axis
    begin
        MoveTo(N-i*k, N*2);  // for negative values of X
        LineTo(N-i*k,  0 );

        MoveTo(N+i*k, N*2);  // for positive values of X
        LineTo(N+i*k,  0 );
    end;

    for i:=1 to N div k do                  //== draw labels on the Y axis
    begin
        MoveTo(N*2, N-i*k);  // for negative values of y
        LineTo( 0 , N-i*k);

        MoveTo(N*2, N+i*k);  // for positive values of y
        LineTo( 0 , N+i*k);
    end;
end;

PaintBox1.Canvas.CopyRect(PaintBox1.Canvas.ClipRect, Bmp.Canvas, Bmp.Canvas.ClipRect);
Bmp.Free;
End;


END.
